summaryrefslogtreecommitdiff
path: root/tests/self-check-report.test
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2011-04-23 23:37:30 +0200
committerStefano Lattarini <stefano.lattarini@gmail.com>2011-04-23 23:40:54 +0200
commit305f9120306aab1343da724696aaa88c7f0dd0ab (patch)
tree06c4075ffc6e073e80849962c46907c5bb9bce8e /tests/self-check-report.test
parentd8f365af42b559f1ae46544c2238febfca664f3a (diff)
downloadautomake-305f9120306aab1343da724696aaa88c7f0dd0ab.tar.gz
test: self check subroutines for skipping/failing of tests
* tests/self-check-report.test: New test. * tests/Makefile.am (TESTS): Update.
Diffstat (limited to 'tests/self-check-report.test')
-rwxr-xr-xtests/self-check-report.test47
1 files changed, 47 insertions, 0 deletions
diff --git a/tests/self-check-report.test b/tests/self-check-report.test
new file mode 100755
index 000000000..639319ab8
--- /dev/null
+++ b/tests/self-check-report.test
@@ -0,0 +1,47 @@
+#! /bin/sh
+# Copyright (C) 2011 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Sanity check for the automake testsuite.
+# Test subroutines to report warnings, and to signal failures, skips
+# and hard errors.
+
+. ./defs || Exit 1
+
+set +e
+
+exec 5>&1
+
+(warn_ foobar) 2>&1 1>&5 | grep '^foobar$' || Exit 1
+(fail_ foo); test $? -eq 1 || Exit 1
+(fail_ foo) 2>&1 1>&5 | grep "^$me: failed test: foo" || Exit 1
+(skip_ foo); test $? -eq 77 || Exit 1
+(skip_ foo) 2>&1 1>&5 | grep "^$me: skipped test: foo" || Exit 1
+(framework_failure_ foo); test $? -eq 99 || Exit 1
+(framework_failure_ foo) 2>&1 1>&5 \
+ | grep "^$me: set-up failure: foo" || Exit 1
+
+stderr_fileno_=6
+
+(warn_ foobar) 6>&1 1>&5 | grep '^foobar$' || Exit 1
+(fail_ foo); test $? -eq 1 || Exit 1
+(fail_ foo) 6>&1 1>&5 | grep "^$me: failed test: foo" || Exit 1
+(skip_ foo); test $? -eq 77 || Exit 1
+(skip_ foo) 6>&1 1>&5 | grep "^$me: skipped test: foo" || Exit 1
+(framework_failure_ foo); test $? -eq 99 || Exit 1
+(framework_failure_ foo) 6>&1 1>&5 \
+ | grep "^$me: set-up failure: foo" || Exit 1
+
+: